using System;
using Esiur.Resource;
using Esiur.Core;
using Esiur.Data;
using Esiur.Net.IIP;
namespace AZ.Compute.Agent {
[ClassId("2f73616a78827890a18fddec371f2217")]
public class Node : DistributedResource {
public Node(DistributedConnection connection, uint instanceId, ulong age, string link) : base(connection, instanceId, age, link) {}
public Node() {}
[Annotation("([String] fileName,[String] arguments) -> AsyncReply`1")]
[Export] public AsyncReply<AZ.Compute.Agent.Job> Compute(string fileName, string arguments) {
var args = new Map<byte, object>(){[0] = fileName, [1] = arguments};
var rt = new AsyncReply<AZ.Compute.Agent.Job>();
_Invoke(0, args)
.Then(x => rt.Trigger((AZ.Compute.Agent.Job)x))
.Error(x => rt.TriggerError(x))
.Chunk(x => rt.TriggerChunk(x));
return rt; }
[Annotation("Single")]
[Export] public float Cpu {
get => (float)properties[0];
set => _SetSync(0, value);
}
[Annotation("UInt32")]
[Export] public uint CpuClock {
get => (uint)properties[1];
set => _SetSync(1, value);
}
[Annotation("UInt32")]
[Export] public uint CpuMaxClock {
get => (uint)properties[2];
set => _SetSync(2, value);
}
[Annotation("String")]
[Export] public string Id {
get => (string)properties[3];
set => _SetSync(3, value);
}
[Annotation("String")]
[Export] public string Ip {
get => (string)properties[4];
set => _SetSync(4, value);
}
[Annotation("Job[]")]
[Export] public AZ.Compute.Agent.Job[] Jobs {
get => (AZ.Compute.Agent.Job[])properties[5];
set => _SetSync(5, value);
}
[Annotation("Single")]
[Export] public float Network {
get => (float)properties[6];
set => _SetSync(6, value);
}
[Annotation("Single")]
[Export] public float NetworkSpeed {
get => (float)properties[7];
set => _SetSync(7, value);
}
[Annotation("Single")]
[Export] public float Ram {
get => (float)properties[8];
set => _SetSync(8, value);
}
[Annotation("UInt32")]
[Export] public uint Tasks {
get => (uint)properties[9];
set => _SetSync(9, value);
}

}
}
